% Runs an LQR control experiment on the bicycle

designLQR;

Ts = 0.01; Tend = 10;
sim('bike', 0:Ts:Tend);

% create and fill in history from sim-created variables
cfg.hist = struct;
cfg.hist.t = simu.time';
cfg.hist.u = simu.signals.values';
cfg.hist.x = simx.signals.values(:, 1:5)';  % ignore positions
cfg.hist.r = 0 * cfg.hist.t;

cfg.trajectory = 1;         % plot trajectory
cfg.discretetime = 0;   
cfg.tendcmd = Tend;         % do not limit command time axis
cfg.plotr = 0;              % do not plot (bogus) reward
cfg.datasource = 'caller';  % take the model from the current workspace


model = BIKE_MODEL;     % needed by bike_plot

bike_plot(cfg);
