%% Main config
ccfg = struct;
ccfg.problem = @edro_rtproblem;
ccfg.datadir = pwd;
% and learning settings
ccfg.trialtime = 2;
ccfg.dupd = 2;
ccfg.maxtime  = 200;
ccfg.explor = 1;
ccfg.explordecay = .955;
ccfg.decaytype = 'trial';
% reset 
ccfg.reset = 'randpos';
% stats settings
ccfg.verb = 5;
ccfg.eps = 0;
ccfg.trialdisp = 1;


%% run learning for joint 5
cfg = ccfg;
cfg.gamma = .95;
cfg.run = 1;
cfg.approx = 'enhanced type=rbfdisc N=[11,11] M=3';
cfg.datafile = 'test_edro_rtlspionline_jnt5_N11x11';
rtlspionline(cfg);


%% run learning for joint 4
cfg = ccfg;
cfg.run = 1;
cfg.gamma = .95;
% note we must stabilize joints 2, 3 due to inertia
% stabilize also joint 5 (manip) to control the effects of its mass/inertia on joint 4
syscfg.xjoints = 4;
syscfg.fixjoints = [2 3 5];
cfg.system_params = {syscfg};
cfg.approx = 'enhanced type=rbfdisc N=[11,5] M=3';
cfg.datafile = 'test_edro_rtlspionline_jnt4_N11x5';
rtlspionline(cfg);


%% run learning for joint 3
cfg = ccfg;
cfg.run = 1;
cfg.gamma = .95;
% note we must stabilize joints 2, 3 due to inertia
% stabilize also joint 5 (manip) to control the effects of its mass/inertia on joint 4
syscfg.xjoints = 3;
syscfg.fixjoints = [2 4 5];
cfg.system_params = {syscfg};
cfg.approx = 'enhanced type=rbfdisc N=[11,5] M=3';
cfg.datafile = 'test_edro_rtlspionline_jnt3_N11x5';
rtlspionline(cfg);



%% run learning for joint 2
cfg = ccfg;
cfg.run = 1;
cfg.gamma = .95;
% note we must stabilize joints 2, 3 due to inertia
% stabilize also joint 5 (manip) to control the effects of its mass/inertia on joint 4
syscfg.xjoints = 2;
syscfg.fixjoints = [3 4 5];
cfg.system_params = {syscfg};
cfg.approx = 'enhanced type=rbfdisc N=[11,5] M=3';
cfg.datafile = 'test_edro_rtlspionline_jnt2_N11x5';
rtlspionline(cfg);



%% determine min#of RBFs for joint 3, larger gamma (also changed safety bounds in the backgd)

cfg = ccfg;
cfg.run = 1;
cfg.trialtime = 3; cfg.dupd = 3; cfg.maxtime  = 300;    % longer trials
cfg.gamma = .98;                                        % change gamma
% note we must stabilize joints 2, 3 due to inertia
% stabilize also joint 5 (manip) to control the effects of its mass/inertia on joint 4
syscfg.xjoints = 3;
syscfg.fixjoints = [2 4 5];
cfg.system_params = {syscfg};
cfg.approx = 'enhanced type=rbfdisc N=[3,3] M=3';
cfg.datafile = 'test_edro_rtlspionline_jnt3_findmin_N3x3';
rtlspionline(cfg);

% Notes:
% 9x5 is OK
% 9x3 is OK
% CHOOSE THIS 7x3 OK
% 5x3 still works, but produces some additional chattering before stabilizing


%% determine min#of RBFs for joint 2, larger gamma (also changed safety bounds in the backgd)

cfg = ccfg;
cfg.run = 1;
cfg.trialtime = 3; cfg.dupd = 3; cfg.maxtime  = 300;    % longer trials
cfg.gamma = .98;                                        % change gamma
% note we must stabilize joints 2, 3 due to inertia
% stabilize also joint 5 (manip) to control the effects of its mass/inertia on joint 4
syscfg.xjoints = 2;
syscfg.fixjoints = [3 4 5];
cfg.system_params = {syscfg};
cfg.approx = 'enhanced type=rbfdisc N=[5,5] M=3';
cfg.datafile = 'test_edro_rtlspionline_jnt2_findmin_N5x5';
rtlspionline(cfg);

% Notes:
% 5x3 works, can be quite unstable if alpha0 large and positive (i.e., tilted backward)
% 7x3 works, does not help stability
% 9x3 seems a bit better
% 7x5 much better
% CHOOSE THIS 5x5 still good -- so indeed, higher resolution is required for angular velocity