% Script to plot optimal Q-function and policy of simple integrator

load int_optimal theta X U DIMS
savepath = 'd:\Work\tex\presentations\2007-03_benelux-07\img\int_optimal';

figh = figure('Position', [0 0 700 300]);
movegui(figh, 'center');

% Compute policy curve
[Qstar ui] = max(theta, [], 2);
ui = lin2ndi(ui, DIMS.dimu);
hstar = U{1}(ui);

% Left: approximate Q-function
subplot(121);

ALPHA = 1;

mesh(X{1}, U{1}, theta', 'EdgeAlpha', ALPHA, 'FaceAlpha', ALPHA); hold on;
xlabel('x');
ylabel('u');
zlabel('Q*(x, u); h*(x)');
plot3(X{1}, hstar, Qstar+.1, 'k', 'LineWidth', 2);
plot3(X{1}, hstar, 0*hstar - 10, 'k', 'LineWidth', 2);

subplot(122);
plot(X{1}, hstar, 'k', 'LineWidth', 2);
xlabel('x'); ylabel('h*(x)');


saveas(figh, [savepath '.fig'], 'fig');
% saveas(figh, [savepath '.eps'], 'psc2');
saveas(figh, [savepath '.png'], 'png');

pause;
close(figh);
