% adhoc script to run one fuzzyqi experiment on the DC motor
clear cfg;

if ~exist('dc_fzqi.mat'),
    cfg.problem = 'dc_problem';
    cfg.run = 1;
    cfg.eps = 1e-5;
    cfg.maxiter = 1000;
    cfg.gamma = .95;
    cfg.datafile = 'dc_fzqi';
    cfg.model_params = {'lqr', 'lin'};

    fuzzyqi(cfg);
end;

% clear cfg;
% cfg.problem = 'dc_problem';
% cfg.datafile = 'dc_fzqi';
% cfg.replay = 1;
% cfg.x0 = rand * [2*pi; 20*pi] - [pi; 10*pi];
% cfg.tend = 1;
% cfg.interph = 0;
% cfg.silent = 1;
% 
% h = fuzzyqi(cfg); plothistory(h);
% 
% cfg.interph = 1;
% h = fuzzyqi(cfg); plothistory(h);

dc_plot('fuzzyq datafile=dc_fzqi');
dc_plot('fuzzyh datafile=dc_fzqi');

